Учебник по индивидуальному размещению окон и дверей

From FreeCAD Documentation
Jump to: navigation, search
This page is a translated version of the page Tutorial custom placing of windows and doors and the translation is 70% complete.

Other languages:
English • ‎italiano • ‎русский

Base ExampleCommandModel.png Руководство

Тема
Архитектура
уровень
Средний
Время для завершения
60 минут
автор
vocx
FreeCAD версия
0.18 или выше
Пример файла (ов)
нет


Введение

Этот учебник покажет как поместить спроектированное пользователем окна и двери в модели здания. Он использует верстаки Draft, Arch, и Sketcher.

Используются следующие инструменты: Draft Grid, Draft Snap, Draft Wire, Arch Wall, Arch Window, и Sketcher NewSketch. Пользователь должен быть знаком с установкой ограничений в эскизах.

Этот учебник был вдохновлён учебниками, написанными jpg87 на форумах FreeCAD.

Установка

1. Откройте FreeCAD, создайте новый пустой документ, и переключитесь на Верстак Arch.

2. Убедитесь, что единицы измерения установлены в меню Правка → Настройки → Основные → Единицы измерения правильно. Например, МКС (м/кг/с/градус) хороши для работы с расстояниями в типичных строениях; и установите число знаков после запятой на 4, чтобы учитывать малейшие доли метра.

3. Используйте кнопку Показывать сетку для показа сетки с достаточным разрешением. Вы можете изменить вид сетки в меню Правка → Настройки → Draft → Сетка и привязка → Сетка. Установите линии через каждые 50 mm, с главными линиями каждые 20 линий (каждый метр), и 1000 линий всего (сетка покрывает площадь 50 x 50 метров).

4. Отодвиньте трёхмерный вид, если сетка слишком близка.

Теперь мы готовы сделать простейшую стену, где мы установим окна и двери.

Установка стены

5. Используйте инструмент Draft Wire для создания полилинии. Ведите её против часовой стрелки.

5.1. Первая точка в (0, 4, 0); в диалоге введите 0 m Enter, 4 m Enter, 0 m Enter.
5.2. Вторая точка в (2, 0, 0); в диалоге введите 2 m Enter, 0 m Enter, 0 m Enter.
5.3. Третья точка в (4, 0, 0); в диалоге введите 4 m Enter, 0 m Enter, 0 m Enter.
5.4. Четвёртая точка в (6, 2, 0); в диалоге введите 6 m Enter, 2 m Enter, 0 m Enter.
5.4. Пятая точка в (6, 5, 0); в диалоге введите 6 m Enter, 5 m Enter, 0 m Enter.
5.5. На клавиатуре нажмите A для завершения полилинии.
5.6. На клавиатуре нажмите 0 для получения аксонометрического вида модели.
Примечание: убедитесь, что чекбокс Относительно (R) не отмечен, когда вводите абсолютные координаты.
Примечание 2: точки могут быть определены указателем мыши по точкам сетки, с помощью панели Draft Snap и метода Draft Grid.
Примечание 3: вы можете создать формы программированием на Python. Учтите, что большинство функций ожидают ввод в миллиметрах.
import FreeCAD
import Draft

p = [FreeCAD.Vector(0.0, 4000.0, 0),
FreeCAD.Vector(2000.0, 0.0, 0.0),
FreeCAD.Vector(4000.0, 0.0, 0.0),
FreeCAD.Vector(6000.0, 2000.0, 0.0),
FreeCAD.Vector(6000.0, 5000.0, 0.0)]

w = Draft.makeWire(p, closed=False)

6. Выделите DWire и кликните инструмент Arch Wall; появится стена с шириной (толщиной) по умолчанию 0,2 м и высотой 3 м.

01 T02 wire wall.png

Базовая линия для стены

02 T02 just wall.png

Стена, полученная из полилинии


Установка стандартных дверей и окон

7. Кликните инструмент Arch Window; в ниспадающем списке Preset выделите Simple door, и установите высоту в 2 м.

7.1. Установите привязку на Draft Midpoint, и попробуйте выделить нижнюю грань передней стены; поверните standard view как требуется, чтобы зацепить грань, а не поверхность стены; когда активна средняя точка, кликните для установки двери.
7.2. Кликните снова инструмент Arch Window, и установите другую дверь, на сей раз в средней точке крайней правой стены; поворачивайте standard view по необходимости.
03 T02 wall place doors.png

Захват по средней точке нижней грани стены для установки двери


Примечание: Sill height это дистанция от пола до нижнего края элемента. Для дверей Sill height обычно 0 m, поскольку двери обычно на уровне пола; с другой стороны, окна обычно отделяет от пола от 0.5 до 1.5 m. Sill height может быть установлен только при создании окна или двери из заготовки. Когда окно или двери вставлены, корректируйте их размещение редактированием вектора DATAPosition [x, y, z] базового эскиза (Sketch).

Создание пользовательских дверей и окон

8. Переключитесь на верстак Sketcher; выделите часть стены справа, где нет двери; кликните на Новый эскиз; выделите FlatFace как метод прикрепления. Если существующая геометрия заслоняет ваш вид, кликните Обзор эскиза чтобы спрятать её.

9. Нарисуйте милый эскиз с тремя замкнутыми полилиниями. Убедитесь в наличии ограничений для всех полилиний.

9.1. Внешняя полилиния - наибольшая, определяет главный размер оконного объекта и размер выреза в стене при внедрении окна в Arch Wall. Убедитесь, что размеры подходяще названы, например Width и Height. Ограничения так же определяют curvature of the outer wire; дайте им подходящее имя, вроде HeightCurve.
9.2. Следующая полилиния это смещение от внешней полилинии, и вместе с ней определяет ширину замоноличиваемой в стену оконной коробки. Назовите смещение соответствующе, например, FrameFixedOffset. Он будет использован как для вертикального, так и горизонтального смещения. Нижнее смещение, при установке в ноль приведёт к касанию оконной коробкой низа окна, это можно использовать для моделирования двери вместо окна. Дайте ей подходящее имя, вроде FrameFixedBottom.
9.3. Третья, внутренняя полилиния это смещение от второй полилинии и вместе с ней определяет подвижную раму окна. Внутренняя полилиния так же определяет размер стекла. Ещё раз, дайте этим смещениям говорящие имена, например, FrameInnerOffset и FrameInnerBottom.
9.4. Чтобы успешно построить эскиз, используйте горизонтальные (Sketcher ConstrainHorizontal) вертикальные (Sketcher ConstrainVertical) ограничения для непосредственных сторон; используйте дополнительную конструктивную геометрию (Sketcher ToggleConstruction) и тангенциальные ограничения (Sketcher ConstrainTangent) для корректного размещения дуг наверху. Поскольку сейчас окно симметрично, не забывайте, когда нужно, ограничения равенства (Sketcher ConstrainEqual), симметрии (Sketcher ConstrainSymmetric) и точки на объекте (Sketcher ConstrainPointOnObject).
04 T02 window constraints outer frame.png

Ограничения для внешних полилиний эскиза, формирующих окно

05 T02 window constraints inner frame.png

Ограничения для внутренних полилиний эскиза, формирующих окно


10. Когда эскиз полностью зафиксирован, нажмите Close для выхода из эскиза (Sketcher LeaveSketch).

10.1. Поскольку лицевая поверхность стены выбирается при начальных шагах создания эскиза, эскиз параллелен с ней, однако он может быть в неверной позиции, вне стены. В этом случае подстройте DATAPosition внутри DATAAttachment Offset. Установите DATAPosition в [4 m, 1 m, 0 m], так что эскиз будет центрирован по стене в одном метре от пола.
10.2. Вы можете видеть именованные ограничения эскиза в DATAConstraints. Значения могут меняться с немедленным визуальным контролем изменений эскиза.
07 T02 window sketch in wall.png

Эскиз окна движется к желательной позиции на стене


06 T02 window sketch properties constraints.png

Именованные ограничения эскиза, которые могут меняться без углубления в эскиз


11. Переключитесь обратно на верстак Arch и примените Arch Window к выбранному новому Sketch002. Будет создано окно, и отверстие под него в стене. Окно сделано из пользовательского эскиза, а не стандартной заготовки, так что ему требуется редактирование для корректного отображения его компонентов, то есть неподвижной рамы, внутренней рамы, и стекла.

08 T02 window basic in wall.png

Пользовательское окно, созданное из эскиза, у него пока нет правильной рамы или стекла


Настройка пользовательского окна

12. В древе проекта под Window выделите Sketch002, и нажмите Space, или измените свойство VIEWVisibility на True.

13. Дважды кликните на Window в древе проекта для начала его редактирования.

13.1. Внутри диалога Window elements имеется две панели, Wires и Components. Там будет три полилинии, Wire0, Wire1 и Wire2, и один компонент, Default. Полилинии указывают на замкнутые кривые, нарисованные на эскизе; компоненты определяют области на эскизе, которые будут выдавлены для создания рамы или стеклянной панели с реальной толщиной, эти области разделяются полилиниями. Окно, созданное из заготовки, уже имеет два компонента, OuterFrame и Glass. Пользовательское окно нужно редактировать для получения такой структуры.
09 T02 window edit default.png

Диалог редактирования окна или двери


13.2. Кликните на Default, потом на кнопке Remove чтобы убрать его.
13.3. Кликните Add; что покажет параметры нового компонента вроде Name, Type, Wires, Thickness, Offset, Hinge, и Opening mode. Дайте имя, вроде OuterFrame, выделите Frame для типа Type, и кликните на Wire0 и Wire1; они будут подсвечены в окне трёхмерного вида. Добавьте небольшое значение для Thickness, 15 mm, и отметьте чекбокс для установки значения по умолчанию. Это значение по умолчанию будет длинной, назначенной параметру DATAFrame; подобное умолчание может быть назначено для параметра DATAOffset. Кликните на кнопке +Create/update componentдля завершения редактирования компонента.
13.4. Кликните Add; дайте другое имя, вроде InnerFrame, укажите Frame для Type и кликните на Wire1 и Wire2. Добавьте подходящего размера Thickness, 60 mm, и Offset, 15 mm. Затем кликните кнопку +Create/update component.
13.5. Кликните Add; дайте другое имя, вроде Glass, выберите Glass panel для Type, и кликните Wire2. Добавьте подходящего размера Thickness, 10 mm и Offset, 40 mm. Затем кликните кнопку +Create/update component. Если любой из трёх компонентов нуждается в модификации, выделите его и нажмите Edit; модификация сохранится только после нажатия кнопки +Create/update component.
10 T02 window edit components.png

Редактирование ранее определённого компонента окна или двери


13.6. Если всё установлено, кликните Close для завершения редактирования окна. Эскиз вновь станет не виден, но окно покажет различимые элементы для OuterFrame, для InnerFrame, и Glass. Задайте для DATAFrame значение 100 mm для толщины по умолчанию, которое будет добавлено к значению, определённому в компоненте OuterFrame.
11 T02 window property view.png

Вид параметров окна для добавления значений по умолчанию для Frame length, Offset length и других опций


12 T02 window finished.png

Итоговое окно с соответствующими компонентами, внедрёнными в стену


Размножение пользовательского окна

14. В древе проектов выделите Window и нижележащий Sketch002. Затем выполните Edit → Duplicate selection, и при запросе ответьте No для дублирования невыбранных зависимостей. Новые Window001 и Sketch003 появятся там же, где оригинальные элементы.

15. Выделите новый Sketch003. Перейдите к параметру DATAMap Mode и кликните на эллипсе возле значения FlatFace. В окне трёхмерного вида выделите левую сторону стены без каких-либо элементов; поверните standard view куда надо. Измените Attachment offset на [-1 m, 0 m, 0 m] для центрирования окна, и кликните OK. Эскиз и окно появятся на новой позиции.

Примечание: операция назначения так же может быть выполнена переключением на верстак Part и использованием меню Part → Attachment.
13 T02 sketch attachment edit.png

Диалог редактирования привязки плоскости эскиза


16. Вы можете настроить размеры нового окна изменением именованных параметров в Sketch003 в DATAConstraints, например, установив Height на 2 m, и Frame Fixed Bottom на 0 m. Затем нажмите Ctrl+R для пересчёта модели. Если окно не показывает увеличенного проёма под новое окно, выделите стену в древе проекта, кликните правой кнопкой и выберите Mark to recompute, затем снова нажмите Ctrl+R.

17. Эти операции меняют позиции нового окна, но проём в окне не выглядит правильно. Оно наклонено, то есть, проём не перпендикулярен поверхности стены, и может даже вырезать другие части стены. Проблема в том, что Window001 сохранила информацию о DATANormal из оригинального Window.

14 T02 sketch 2 attached slanted.png

Неправильный проём в стене из-за ошибочной нормали (Normal) окна


Нормали дверей и окон

18. Each Arch Window object controls the extrusion of its body and the opening that is created in its host wall by means of the DATANormal.

The normal is a vector [x, y, z] that indicates a direction perpedicular to a wall. When a window or door preset is created with the Arch Window tool directly over an Arch Wall, the normal is automatically calculated, and the resulting window or door is correctly aligned; the first two objects, Door and Door001, were created in this way.

In similar way, when a sketch is created by selecting a planar surface, it is oriented on this plane. Then when the Arch Window tool is used, the window will use as normal the perpendicular direction to the sketch. This was the case with the third object, the custom Window.

If the window already exists and needs to be moved, as was the case with the duplicated Window001 object, the sketch needs to be remapped to another plane; doing this moves both the sketch and the window, but the latter doesn't automatically update its normal, so it has incorrect extrusion information. The normal needs to be calculated manually and written to DATANormal.

The three values of the normal vector are calculated as following.

x = -sin(angle)
y = cos(angle)
z = 0

Where angle is the angle of the local Z axis of the sketch with respect to the global Y axis.

When a sketch is created, it always has two axes, a local X (red) and a local Y (green). If the sketch is mapped to the global XY working plane, then these axes are aligned; but if the sketch is mapped on the global XZ or global YZ planes, as is common with windows and doors (the sketches are "standing up"), then the local Z (blue) forms an angle with the global Y axis; this angle varies from -180 to 180 degrees. The angle is considered positive if it opens counterclockwise, and it is negative if it opens clockwise, starting from the global Y axis.

15 T02 sketch local coordinates.png

Local coordinates of a sketch that is "standing up", that is, mapped to the global XZ plane


16 T02 sketch correct normal direction.png

Intended directions of the normals for each door and window


If we look at the geometry created so far, we see the following normals.

Door
The local Z is aligned with the global Y, therefore, the angle is zero. The normal vector is
x = -sin(0) = 0
y = cos(0) = 1
z = 0

or DATANormal is [0, 1, 0].

Door001
The local Z is rotated 90 degrees from the global Y, therefore, the angle is 90 (positive, because it opens counterclockwise). The normal vector is
x = -sin(90) = -1
y = cos(90) = 0
z = 0

or DATANormal is [-1, 0, 0].

Window
The local Z is rotated 45 degrees from the global Y, therefore, the angle is 45 (positive, because it opens counterclockwise). The normal vector is
x = -sin(45) = -0.7071
y = cos(45) = 0.7071
z = 0

or DATANormal is [-0.7071, 0.7071, 0].

Window001
The local Z direction is found by using the Draft Dimension tool and measuring the angle that the wall trace (Wire) makes with the global Y axis, or any line aligned to it. This angle is 26.57; the desired angle is the complement to this, so 90 - 26.57 = 63.43.

This means the local Z axis is rotated 63.43 degrees from the global Y, therefore, the angle is -63.46 (negative, because it opens clockwise). The normal vector is

x = -sin(-63.43) = 0.8943
y = cos(-63.43) = 0.4472
z = 0

Therefore DATANormal should be changed to [0.8943, 0.4472, 0].

After doing these changes, recompute the model with Ctrl+R. If the wall doesn't update the hole, select it in the tree view, right click and choose Mark to recompute, then press Ctrl+R again.

19. The orientation of the extrusion of the window is resolved, together with the opening in the wall.

17 T02 sketch 2 attached correctly.png

Correct opening in the wall due to proper Normal of the window


Final remarks

20. As demonstrated, the initial placement of the Arch Window is very important. The user should either

  • use the Arch Window tool to insert and automatically align a preset to a wall, or
  • map a sketch to the desired wall, and build the window after that.

If a window already exists, and it needs to be moved, the supporting sketch should be remapped to a new plane, and the DATANormal of the window needs to be recalculated.

The new normal direction can be obtained by measuring the angle of the new wall with respect to the global Y axis, considering whether this angle is positive (counterclockwise) or negative (clockwise), and using a simple formula.

x = -sin(angle)
y = cos(angle)
z = 0

To confirm that the operations are correct, the absolute magnitude of the normal vector should be one. That is,

abs(N) = 1 = sqrt(x^2 + y^2 + z^2)
abs(N) = 1 = sqrt(sin^2(angle) + cos^2(angle) + z^2)